(*
    DIS386 test code for Turbo Pascal
    Copyright (c) 1994-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
uses Dis386;

procedure TestProcBegin; assembler;
asm
  jmp   @@Exit
  mov   ax, [si+bx+$43] (* 8086 instruction *)
  rep   lodsb           (* 8086 intruction with prefix *)
  DB    $2E, $67, $66, $8B, $84, $99, $34, $12, $00, $00
  (* The above 10-byte 386 monster should be: mov eax,cs:[ecx+ebx*4+1234h] *)
  DB    $0F, $08        (* 486 INVD instruction *)
  DB    $0F, $05        (* Undocumented 286 LOADALL instruction *)
  DB    $0F, $A2        (* 486DX2/Pentium CPUID instruction *)
  DB    $0F, $31        (* Pentium only RDTSC *)
  DB    $8E,$3E,$34,$12 (* Illegal segment register addressing *)
  DB    $D6             (* Undocumented LALC (aka SETALC) instruction *)
  DB    $0F,$C7,$04     (* Pentium CMPXCHG8B *)
@@Exit:
end;

(* Dummy procedure to mark the end of TestProcBegin *)
procedure TestProcEnd; assembler;
asm
end;

var
  D3C: D3Control;
  S  : string;
begin
  WriteLn( 'DIS386 test program' );
  WriteLn( '*** Start ***' );

  D3C.CPtr := Addr( TestProcBegin );
  D3C.VSeg := Seg( TestProcBegin );
  D3C.VOfs := Ofs( TestProcBegin );
  D3C.DumpSize := 24;
  D3C.Flags := 0;

  repeat
    d3Decode( D3C, S );
    WriteLn( S );
  until( longint(D3C.CPtr) >= longint(@TestProcEnd) );

  WriteLn( '*** End ***' );
end.
