/*
    A line-oriented disassembler for the 386
    Copyright (c) 1992-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    Note: supports up to the Pentium instruction set
*/
#ifndef _DIS386_H_
#define _DIS386_H

#define D3F_USE32       0x10
#define D3F_SOURCE      0x10
#define D3F_UPCASE      0x10
#define D3F_INDENT      0x10

typedef struct {
        /* Fields to be filled by caller */
        unsigned        Flags;
        unsigned        VSeg;
        long            VOfs;
        char far        *CPtr;
        char far        *BPtr;
        unsigned        DumpSize;
        /* Fields filled in by disassembler */
        char            OName;
        char            OArg1;
        char            OArg2;
        char            OArg3;
        unsigned        OPrefix;
        char            Reserved[10];
} D3CONTROL;

#ifdef __cplusplus
extern "C" unsigned far pascal dis3_Decode( D3CONTROL far * );
#else
unsigned far pascal dis3_Decode( D3CONTROL far * );
#endif

#endif  /* _DIS386_H_ */
