(*
    A line-oriented disassembler for the 386
    Copyright (c) 1992-2003,2004 Alessandro Scotti
    http://www.ascotti.org/

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit Dis386;
interface

const
  D3F_USE32     = $10;
  D3F_SOURCE    = $20;
  D3F_UPCASE    = $40;
  D3F_INDENT    = $80;
type
  (* Control structure: note that fields CPtr and VOfs are *)
  (* automatically incremented by the right amount after each *)
  (* call to dis3_Decode *)
  D3Control = record
    (* Fields to be filled by caller *)
    Flags       : word;                 (* Flags *)
    VSeg        : word;                 (* Virtual segment *)
    VOfs        : longint;              (* Virtual offset *)
    CPtr        : ^byte;                (* Pointer to code to disassemble *)
    BPtr        : ^char;                (* Pointer to output buffer *)
    DumpSize    : word;                 (* Bytes reserved for code dump *)
    (* Fields filled in by disassembler *)
    OName       : byte;                 (* Opcode name *)
    OArg1       : byte;                 (* Arguments *)
    OArg2       : byte;
    OArg3       : byte;
    OPrefix     : word;                 (* Prefixes *)
    Reserved    : array[ 1..10 ] of byte;
  end;

function dis3_Decode( Ctrl: pointer ): word;
function d3Decode( var Ctrl: D3Control; var S: string ): word;

implementation

function dis3_Decode; external;
{$L DIS386}

function d3Decode;
begin
  Ctrl.BPtr := @S[1];
  d3Decode := dis3_Decode( @Ctrl );
  S[0] := #255;
  S[0] := char( Pos(#0,S)-1 );
end;

end.
